package com.tofly.water.service;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.tofly.water.entity.LaborPlan;
import com.tofly.water.entity.dto.LaborPlanDto;

import org.springframework.web.multipart.MultipartFile;

import java.io.Serializable;
import java.util.List;

/**
 * 调度方案管理(LaborPlan)表服务接口
 *
 * @author HaiQiu
 * @since 2022-11-22 11:41:09
 */
public interface LaborPlanService extends IService<LaborPlan> {

    /**
     * 根据ID查询
     *
     * @param id id
     * @return 数据
     */
    LaborPlan get(Serializable id);

    /**
     * 新增
     *
     * @param laborPlanDto 实体
     */
    void insert(LaborPlanDto laborPlanDto);

    /**
     * 修改
     *
     * @param laborPlanDto 实体
     */
    void edit(LaborPlanDto laborPlanDto);

    /**
     * 批量删除
     *
     * @param idList 数据ID集合
     */
    void delete(List<Long> idList);

    /**
     * 生成模板下载
     */
    void template();

    /**
     * 数据导入
     *
     * @param file 文件
     */
    void importData(MultipartFile file);

    /**
     * 分页查询
     *
     * @param page      分页
     * @param laborPlan 查询wrapper
     * @return 数据集合
     */
    Page<LaborPlan> pageList(Page page, LaborPlan laborPlan);

    /**
     * 数据导出
     *
     * @param page      分页
     * @param laborPlan 查询模型
     * @param isAll     是否导出全部数据，true是，false否
     */
    void export(Page page, LaborPlan laborPlan, Boolean isAll);

    /**
     * 查询所有数据
     *
     * @param laborPlan 查询条件
     * @return 查询所有数据
     */
    List<LaborPlan> allList(LaborPlan laborPlan);
}

